' Steini's Mini Compiler
'
$STACK 1024*16
$LIB ALL OFF
$COMPILE EXE

' Syntax of a Line: label: statement 'Remark
' Definition of a procedure: sub name(params)


DIM errFlag AS SHARED INTEGER		'Unterlief ein Fehler??
DIM inSUB AS SHARED INTEGER		'Sind wir in einer Prozedur
DIM pasVARS AS SHARED INTEGER		'Wieviele Vars. bergeben wurden
DIM stackBYTES AS SHARED INTEGER	'Wieviele Bytes an Stack die Proz.
					'bentigte.
DIM subVARS AS SHARED INTEGER		'Wieviele Variablen zu dieser Proz
					'gehren.
DIM curVARS AS SHARED INTEGER		'Wieviele Variablen grad aktuell sind
DIM varNAME(1024) AS SHARED STRING	'Namen der Variablen
DIM varPOS(1024) AS SHARED STRING	'Assembler-Code fr die Variable
DIM varTYP(1024) AS SHARED INTEGER	'Variablentypus

TYPE typCOMMAND
	CmdRetval	AS INTEGER	'Rckgabewert
        Param(16)	AS INTEGER	'Parameter an die Funktion
        Need(16)	AS INTEGER	'Welche Funktionen werden gebraucht?
        CodeLen		AS INTEGER	'Wie lang ist der ASM-Code
END TYPE

DIM cmdASM(512) AS SHARED LONG		'Wo befindet sich der Code
DIM cmdINF(512) AS SHARED typCOMMAND	'Die Informationen ber die Kommandos
DIM cmdSTR(512) AS SHARED STRING	'Kommandostrings
DIM cmdMAX AS SHARED INTEGER		'Wie viele Kommandos gibt es
DIM cmdUSED(512) AS SHARED INTEGER	'Wurde dieses Kommando benutzt?

CLS
ReadCommands
OPEN "TEST.TXT" FOR INPUT AS #1
OPEN "TEST.ASM" FOR OUTPUT AS #2
	PRINT #2,";Compile:"+TIME$+" "+DATE$
        PRINT #2,"%include "+CHR$(34)+"LIB\INIT.ASM"+CHR$(34)
        PRINT #2,"progID:	db 'PRG'"
        PRINT #2,""
        WHILE NOT EOF(1)
        	LINE INPUT #1, curLine$
                SyntaxLine curLine$
        WEND
        PRINT #2,"libID:	db 'LIB'"
        PRINT #2,CHR$(13,10)+"prog_ende:"
CLOSE #1,#2

SHELL "NASM TEST.ASM"
IF DIR$("TEST.COM")<>"" THEN KILL "TEST.COM"
NAME "TEST" AS "TEST.COM"

'-------------------------------------------------------------------------
'Zerlegt eine Zeile
SUB SyntaxLine(curLine$)

	'Mache vorne + hinten die Leerzeichen weg
        Lin$=TRIM$(curLine$)

        'entferne einen Kommentar (falls vorhanden)
        removeRemark Lin$
        IF Lin$="" THEN EXIT SUB

        'ok. Hole das Statement aus dieser Zeile
        x%=INSTR(Lin$,ANY " (=")
        IF x%=0 THEN EXIT SUB		'Kein Statement....
        statement$=TRIM$(LEFT$(Lin$,x%-1))
        Lin$=TRIM$(MID$(Lin$,x%+1))

        'Untersuche Statement auf Build-In Statements
        SELECT CASE statement$
        CASE "sub"	: buildinSUB Lin$
        CASE "end"	: buildinEND Lin$
        CASE "int"	: defineINT Lin$
        CASE ELSE
                'Kein eingebautes Statement. Suche Variablen durch...
                var%=searchVAR(statement$)
                IF var% > 0 THEN
                	buildinVARop var%,Lin$
                ELSE
                        prog%=searchCMD(statement$)
                        IF prog% > 0 THEN
                        	'bla bla
                        ELSE
        			PRINT "Error! No such Statement! :"+curLine$
                        END IF
                END IF
        END SELECT
END SUB

'-------------------------------------------------------------------------
'Diese Prozedur entfernt die Kommentare am Zeilenende
'Das Hauptproblem ist, dass man aufpassen muss, dass man nicht dummerweise
'ein "'" erwischt. Das knnte nmlich genausogut ein String sein.
SUB removeRemark(curLine$)
	IF LEFT$(curLine$,1)="'" THEN
        	curLine$=""
                EXIT SUB
        END IF

        FOR i%=1 TO LEN(curLine$)
                SELECT CASE ASC(curLine$,i%)	'Werte die Zeichen aus
                CASE 34
                	IF s%=0 THEN s%=1 ELSE s%=0
                CASE 39
                	IF s%=0 THEN 		'Ausserhalb eines Strings
                        	f%=i%-1		'wurde ein ' gefunden.
                        	EXIT FOR	' -> Kommentar
                        END IF
                END SELECT
        NEXT i%

        IF f%>0 THEN curLine$=LEFT$(curLine$,f%)
END SUB

'-------------------------------------------------------------------------
'Das ist der Prozeduren Teil. Es geht hier darum eine neue Prozedur
'anzulegen.
SUB buildinSUB(curLine$)

	'Testen ob nicht schon eine Prozedur offen ist...
        IF inSUB THEN
        	PRINT "Error! Can't define a procedure in a procedure!"
                errFlag=-1
                EXIT SUB
        END IF

        'Den Parameter-Teil abtrennen
        x%=INSTR(curLine$,"(")
        IF x%=0 THEN
        	PRINT "Error! Wrong sub syntax. Syntax: sub name(param)"
                errFlag=-1
                EXIT SUB
        END IF
        sub_name$=LEFT$(curLine$,x%-1)
        params$=MID$(curLine$,x%+1)
        x%=INSTR(params$,")")
        IF x%=0 THEN
        	PRINT "Error! Wrong sub syntax. Syntax: sub name(param)"
                errFlag=-1
                EXIT SUB
        END IF
        params$=LEFT$(params$,x%-1)

        inSUB=-1			'neue Prozedur ffnen
        stackBYTES=0			'wir haben noch keine lokalen Vars.
        subVARS=0			'keine lokalen Vars

        'Neue Dinge in die ASM-Datei schreiben
        PRINT #2,"__"+sub_name$+":"
        PRINT #2,"	push	bp"
        PRINT #2,"	mov	bp,sp"

        'Jetzt bergeben wir die ganzen Parameter

END SUB

'-------------------------------------------------------------------------
'schliet eine Prozedur ab.
SUB buildinEND_SUB()

	'Anzahl der Variablen verkleinern. Lokale Vars. lschen
	DECR curVARS,subVARS

	'Prozedurende in Datei schreiben
        IF stackBYTES>0 THEN PRINT #2,"	add	sp,";stackBYTES
        PRINT #2,"	pop	bp"
        IF pasVARS=0 THEN
        	PRINT #2,"	ret"
        ELSE
        	PRINT #2,"	ret	";pasVARS*2;CHR$(13,10)
        END IF

        'inSUB Flag lschen. Is ja nicht mehr der fall!
        inSUB=0
END SUB

'-------------------------------------------------------------------------
'Behandelt ein END Statement
SUB buildinEND(curLine$)

	'Untersuche ob es ein Programmende ist
        SELECT CASE curLine$
        CASE "program"
        	'ok. ABSOULTES Programmende
                PRINT	#2,"	jmp	prog_halt"
        CASE "brutal"
        	'noch brutaleres ende
                PRINT	#2,"	jmp	prog_quit"
        CASE "sub"
                buildinEND_SUB
        END SELECT
        'Color 14,1 : ? curLine$
END SUB

'-------------------------------------------------------------------------
'Sucht eine Variable
FUNCTION searchVAR(varNAME$) AS INTEGER
	FOR i%=1 TO curVARS
                IF varNAME$=varNAME(i%) THEN
                	FUNCTION=i%
                        EXIT FUNCTION
                END IF
        NEXT i%
END FUNCTION

'-------------------------------------------------------------------------
'Fhrt eine Variablenoperation durch z.B. a=0 oder i=a
SUB buildinVARop(var%,curLine$)

	'2. Teil durch den Parser lassen
        Mparse curLine$

        PRINT #2,"	mov	"+varPOS(var%)+",ax"
END SUB

'-------------------------------------------------------------------------
'Definiert einen Integer
SUB defineINT(curLine$)

	'berprfen ob eine solche Variable schon existiert...
        IF searchVAR(curLine$)<>0 THEN
        	PRINT "Error! Integer ";curLine$;" already defined!"
                errFlag=-1
                EXIT SUB
        END IF

        'So. Entweder global oder lokal definieren
        INCR curVARS				'Anzahl der Variablen+1
        IF inSUB THEN
                'Lokale definition
                INCR subVARS			'Anzahl der lok-Variablen+1
                INCR stackBYTES,2		'2 Byte mehr STACK
                varNAME(curVARS)=curLine$	'Varname festlegen
                varPOS(curVARS)="[bp-"+TRIM$(STR$(stackBYTES))+"]"
                PRINT #2,"	push	ax"	'SP-2
        ELSE
                'Globale definition
                varNAME(curVARS)=curLine$	'Varname festlegen
                varPOS(curVARS)="[var_"+curLine$+"]"

                'Globale defintion schreiben
                PRINT #2,"var_"+curLine$+":	dw 0"
        END IF
END SUB

'-------------------------------------------------------------------------
' Liet die Kommandos ein
SUB ReadCommands
	OPEN "COMMAND.DAT" FOR BINARY AS #1
                GET #1,,cmdMAX
                FOR i%=1 TO cmdMAX
                        GET #1,,sLen%
                        GET$ #1,sLen%,cmdSTR(i%)
                        GET #1,,cmdINF(i%)
                        cmdASM(i%)=SEEK(1)
                        SEEK #1,SEEK(1)+cmdINF(i%).CodeLen
                NEXT i%
        CLOSE #1
END SUB

'-------------------------------------------------------------------------
' Sucht eine Funktion
FUNCTION searchCMD(cmdName$) AS INTEGER
	FOR i%=1 TO cmdMAX
                IF cmdName$=cmdSTR(i%) THEN
                	FUNCTION=i%
                        EXIT FUNCTION
                END IF
        NEXT i%
END FUNCTION

'-------------------------------------------------------------------------
$INCLUDE"SRC\PARSE.BAS"